{{- if .Values.serviceAccount.create -}}
apiVersion: v1
kind: ServiceAccount
metadata:
  name: {{ include "capi-rancher-import.serviceAccountName" . }}
  labels:
    {{- include "capi-rancher-import.labels" . | nindent 4 }}
  {{- with .Values.serviceAccount.annotations }}
  annotations:
    {{- toYaml . | nindent 4 }}
  {{- end }}
{{- end }}
---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRole
metadata:
  name: {{ include "capi-rancher-import.serviceAccountName" . }}
rules:

  - apiGroups: [""]
    resources: ["namespaces"]
    verbs: ["list","get","watch"]

  # needed to know if CAPI or Rancher CRDs exist:
  - apiGroups: [apiextensions.k8s.io]
    resources: [customresourcedefinitions]
    verbs: [list, get]

  # clusterregistrationtokens.management.cattle.io are the objects that 
  # our controller watches
  # Kopf need to be able to patch them to track resources
  - apiGroups: [management.cattle.io]
    resources: [clusterregistrationtokens]
    verbs: [list, watch, get, patch]

  # read-only access for watching cluster-wide
  # on the resources we need to look at
  - apiGroups: [provisioning.cattle.io]
    resources: [clusters]
    verbs: [list, watch, get]
  - apiGroups: [management.cattle.io]
    resources: [clusters]
    verbs: [list, watch, get]

  # objects that we need to create:
  - apiGroups: [kustomize.toolkit.fluxcd.io]
    resources: [kustomizations]
    verbs: [list, watch, get, create, update, delete]

  # Kopf Framework: posting the events about the handlers progress/errors.
  - apiGroups: [events.k8s.io]
    resources: [events]
    verbs: [create]
  - apiGroups: [""]
    resources: [events]
    verbs: [create]

---
apiVersion: rbac.authorization.k8s.io/v1
kind: ClusterRoleBinding
metadata:
  name: {{ include "capi-rancher-import.serviceAccountName" . }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: {{ include "capi-rancher-import.serviceAccountName" . }}
subjects:
  - kind: ServiceAccount
    namespace: {{ .Release.Namespace }}
    name: {{ include "capi-rancher-import.serviceAccountName" . }}
